{  Beispiel fr eine Personalausweisnummer
   1220000016D<<4509303<0110052<<<<<<1
   aaaabbbbbpD__jjmmttp<jjmmjjp______p

   aaaa   Erstwohnsitzkennzahl
   bbbbb  Fortlaufende Nummer
   jjmmtt Jahr Monat Tag Gerburtstag und Ablaufdatum
   p      Prfziffer

   Prfziffern werden gebildet, indem die erste Ziffer mit 7,
   die zweite mit 3, die dritte mit 1, die vierte wieder mit
   7 u.s.w. multipliziert wird und das Ganze summiert.
   Die Einerstelle ist dann die Prfziffer.

   Beispiel: aaaabbbbb 17 + 23 + 2 + 1     = 16  p = 6
             jjmmtt    47 + 53 + 97 + 33 = 403 p = 3
             jjmmtt    13 + 1 + 5           = 412 p = 2

             gesamt    17 + 2 3 + 2 + 1 + 67
                     + 43 + 5 + 93 + 3 + 33
                     + 17 + 13 + 53 + 2 =141    p = 1}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    EStadt: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    EGeb: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    EAblauf: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    EP: TEdit;
    Label5: TLabel;
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure EStadtChange(Sender: TObject);
    procedure EGebChange(Sender: TObject);
    procedure EAblaufChange(Sender: TObject);
    procedure EPChange(Sender: TObject);
    procedure EStadtKeyPress(Sender: TObject; var Key: Char);
    procedure EGebKeyPress(Sender: TObject; var Key: Char);
    procedure EAblaufKeyPress(Sender: TObject; var Key: Char);
    procedure EPKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure springe(a,b: Tedit; k:integer);
begin
 if length(a.text)>=k then b.SetFocus;
end;

function pruefsumme(s:string): integer;
  var k: integer;
begin
 result := 0;
 for k := 1 to length(s) do
   Case k mod 3 of 1: result := result + 7*StrToInt(s[k]);
                   2: result := result + 3*StrToInt(s[k]);
                   0: result := result + StrToInt(s[k]);
   End;
end;

function kontrolle(s: string; k:integer):boolean;
begin
 if StrToInt(s[length(s)]) = k mod 10 then result := true
   else result := false;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var s, g, a, p :string;
      ps: integer; //Prfsumme
begin
   s := estadt.Text;
   g := egeb.text;
   a := eablauf.Text;
   p := ep.text;
   memo1.Lines.Clear;
   ps := pruefsumme(copy(s,1,9));
   if kontrolle(s,ps) then
     memo1.Lines.Add('Die Erstwohnsitzkennzahl ist korrekt.') else
       memo1.Lines.Add('Die Erstwohnsitzkennzahl ist geflscht.');
   ps := pruefsumme(copy(g,1,6));
   if kontrolle(g,ps) then
     memo1.Lines.Add('Das Geburtsdatum ist korrekt.') else
       memo1.Lines.Add('Das Geburtsdatum ist geflscht.');
   ps := pruefsumme(copy(a,1,6));
   if kontrolle(a,ps) then
     memo1.Lines.Add('Das Ablaufdatum ist korrekt.') else
       memo1.Lines.Add('Das Ablaufdatum ist geflscht.');
   ps := pruefsumme(copy(s+g+a,1,10+7+7));
   if kontrolle(p,ps) then
     memo1.Lines.Add('Der Personalausweis ist korrekt.') else
       memo1.Lines.Add('Der Personalausweis ist geflscht.');
end;

procedure TForm1.EStadtChange(Sender: TObject);
begin
 springe(eStadt,Egeb,10);
end;

procedure TForm1.EGebChange(Sender: TObject);
begin
  springe(Egeb,Eablauf,7);
end;

procedure TForm1.EAblaufChange(Sender: TObject);
begin
  springe(EAblauf,Ep,7);
end;

procedure TForm1.EPChange(Sender: TObject);
begin
  if Ep.text >'' then  Button1Click(Nil);
end;

procedure TForm1.EStadtKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then EStadtChange(Nil);
end;

procedure TForm1.EGebKeyPress(Sender: TObject; var Key: Char);
begin
 if key = #13 then EGebChange(Nil);
end;

procedure TForm1.EAblaufKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then EAblaufChange(Nil);
end;

procedure TForm1.EPKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then EPChange(Nil);
end;

end.
